Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkSimpleScalarTree Class Reference

`#include <vtkSimpleScalarTree.h>`

Inheritance diagram for vtkSimpleScalarTree:

[legend]
Collaboration diagram for vtkSimpleScalarTree:

[legend]
List of all members.

## Detailed Description

organize data according to scalar values (used to accelerate contouring operations)

Date:
  2002/01/22 15:28:12

Revision:
  1.3

vtkSimpleScalarTree creates a pointerless binary tree that helps search for cells that lie within a particular scalar range. This object is used to accelerate some contouring (and other scalar-based techniques).

The tree consists of an array of (min,max) scalar range pairs per node in the tree. The (min,max) range is determined from looking at the range of the children of the tree node. If the node is a leaf, then the range is determined by scanning the range of scalar data in n cells in the dataset. The n cells are determined by arbitrary selecting cell ids from id(i) to id(i+n), and where n is specified using the BranchingFactor ivar. Note that leaf node i=0 contains the scalar range computed from cell ids (0,n-1); leaf node i=1 contains the range from cell ids (n,2n-1); and so on. The implication is that there are no direct lists of cell ids per leaf node, instead the cell ids are implicitly known.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (97%)

CVS logs (CVSweb):
  - .`cxx` (`/Filtering/vtkSimpleScalarTree.cxx)`
  - .`h` (`/Filtering/vtkSimpleScalarTree.h)`

Definition at line 58 of file vtkSimpleScalarTree.h.

## [NOHEADER]
typedef vtkScalarTree | Superclass
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
int | IsTypeOf (const char *type)
vtkSimpleScalarTree * | SafeDownCast (vtkObject *o)
## Public Methods
virtual void | BuildTree ()
virtual void | Initialize ()
virtual void | InitTraversal (float scalarValue)
virtual void | SetBranchingFactor (int)
virtual int | GetBranchingFactor ()
virtual int | GetLevel ()
virtual void | SetMaxLevel (int)
virtual int | GetMaxLevel ()
virtual vtkCell * | GetNextCell (vtkIdType &cellId, vtkIdList *&ptIds, vtkDataArray *cellScalars)
## Static Public Methods
vtkSimpleScalarTree * | New ()
## Protected Methods
| vtkSimpleScalarTree ()
| ~vtkSimpleScalarTree ()
## Protected Attributes
vtkDataArray * | Scalars
int | MaxLevel
int | Level
int | BranchingFactor
vtkScalarNode * | Tree
int | TreeSize

## Member Typedef Documentation

typedef vtkScalarTree vtkSimpleScalarTree::Superclass

| Standard type related macros and PrintSelf() method. Reimplemented from vtkScalarTree. Definition at line 67 of file vtkSimpleScalarTree.h.

## Constructor & Destructor Documentation

vtkSimpleScalarTree::vtkSimpleScalarTree | ( |  | ) | `[protected]`

vtkSimpleScalarTree::~vtkSimpleScalarTree | ( |  | ) | `[protected]`

## Member Function Documentation

vtkSimpleScalarTree* vtkSimpleScalarTree::New | ( |  | ) | `[static]`

| Instantiate scalar tree with maximum level of 20 and branching factor of 5. Reimplemented from vtkObject.

virtual const char* vtkSimpleScalarTree::GetClassName | ( |  | ) | `[virtual]`

| Standard type related macros and PrintSelf() method. Reimplemented from vtkScalarTree.

int vtkSimpleScalarTree::IsTypeOf | ( | const char * | type | ) | `[static]`

| Standard type related macros and PrintSelf() method. Reimplemented from vtkScalarTree.

virtual int vtkSimpleScalarTree::IsA | ( | const char * | type | ) | `[virtual]`

| Standard type related macros and PrintSelf() method. Reimplemented from vtkScalarTree.

vtkSimpleScalarTree* vtkSimpleScalarTree::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Standard type related macros and PrintSelf() method. Reimplemented from vtkScalarTree.

void vtkSimpleScalarTree::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Standard type related macros and PrintSelf() method. Reimplemented from vtkScalarTree.

virtual void vtkSimpleScalarTree::SetBranchingFactor | ( | int |  | ) | `[virtual]`

| Set the branching factor for the tree. This is the number of children per tree node. Smaller values (minimum is 2) mean deeper trees and more memory overhead. Larger values mean shallower trees, less memory usage, but worse performance.

virtual int vtkSimpleScalarTree::GetBranchingFactor | ( |  | ) | `[virtual]`

| Set the branching factor for the tree. This is the number of children per tree node. Smaller values (minimum is 2) mean deeper trees and more memory overhead. Larger values mean shallower trees, less memory usage, but worse performance.

virtual int vtkSimpleScalarTree::GetLevel | ( |  | ) | `[virtual]`

| Get the level of the scalar tree. This value may change each time the scalar tree is built and the branching factor changes.

virtual void vtkSimpleScalarTree::SetMaxLevel | ( | int |  | ) | `[virtual]`

| Set the maximum allowable level for the tree.

virtual int vtkSimpleScalarTree::GetMaxLevel | ( |  | ) | `[virtual]`

| Set the maximum allowable level for the tree.

virtual void vtkSimpleScalarTree::BuildTree | ( |  | ) | `[virtual]`

| Construct the scalar tree from the dataset provided. Checks build times and modified time from input and reconstructs the tree if necessary. Implements vtkScalarTree.

virtual void vtkSimpleScalarTree::Initialize | ( |  | ) | `[virtual]`

| Initialize locator. Frees memory and resets object as appropriate. Implements vtkScalarTree.

virtual void vtkSimpleScalarTree::InitTraversal | ( | float | scalarValue | ) | `[virtual]`

| Begin to traverse the cells based on a scalar value. Returned cells will have scalar values that span the scalar value specified. Implements vtkScalarTree.

virtual vtkCell* vtkSimpleScalarTree::GetNextCell | ( | vtkIdType & | cellId,
|  | vtkIdList *& | ptIds,
|  | vtkDataArray * | cellScalars
| ) | `[virtual]`

| Return the next cell that may contain scalar value specified to initialize traversal. The value NULL is returned if the list is exhausted. Make sure that InitTraversal() has been invoked first or you'll get erratic behavior. Implements vtkScalarTree.

## Member Data Documentation

vtkDataArray* vtkSimpleScalarTree::Scalars`[protected]`

| Reimplemented from vtkScalarTree. Definition at line 117 of file vtkSimpleScalarTree.h.

int vtkSimpleScalarTree::MaxLevel`[protected]`

| Definition at line 118 of file vtkSimpleScalarTree.h.

int vtkSimpleScalarTree::Level`[protected]`

| Definition at line 119 of file vtkSimpleScalarTree.h.

int vtkSimpleScalarTree::BranchingFactor`[protected]`

| Definition at line 120 of file vtkSimpleScalarTree.h.

vtkScalarNode* vtkSimpleScalarTree::Tree`[protected]`

| Definition at line 121 of file vtkSimpleScalarTree.h.

int vtkSimpleScalarTree::TreeSize`[protected]`

| Definition at line 122 of file vtkSimpleScalarTree.h.

The documentation for this class was generated from the following file:

- Filtering/vtkSimpleScalarTree.h